﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

using Infragistics.Win.UltraWinToolbars;

namespace Test_TbMgr
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void butTestNormal_Click(object sender, EventArgs e)
        {
            openForm("Form Opens Normally");
        }

        private void butTestSlow_Click(object sender, EventArgs e)
        {
            openForm("Form&Opens Slowly");
        }

        private void butTestSlower_Click(object sender, EventArgs e)
        {
            openForm("Form Opens&Slower: Related to the Caption");
        }

        private void butTestCaption_Click(object sender, EventArgs e)
        {
            openForm(ultraTextEditor1.Text);
        }

        private void openForm(string caption)
        {
            NewForm frm = new NewForm();
            frm.Text = caption;
            frm.Show();

            updateToolBar(frm);
        }

        private void updateToolBar(NewForm frm)
        {
            UltraToolbarsManager TbMgr = frm.ultraToolbarsManager1;
            Stopwatch timerTotal = Stopwatch.StartNew();
            Stopwatch timerIteration = Stopwatch.StartNew();
            bool flipEnabled = false;
            for (int idx = 0; idx < 20; idx++)
            {
                TbMgr.EventManager.SetEnabled(EventGroups.AllEvents, false);
                TbMgr.BeginUpdate();

                foreach (ToolBase tool in TbMgr.Tools)
                {
                    tool.SharedProps.Enabled = flipEnabled;
                    if(tool is PopupColorPickerTool) ((PopupColorPickerTool)tool).SelectedColor = flipEnabled ? SystemColors.WindowText : Color.Transparent;
                    if (tool is FontListTool) ((FontListTool)tool).SelectedIndex = flipEnabled ? 0 : 1;
                }

                flipEnabled = !flipEnabled;

                //Debug.Print("updateToolStates, toolsUpdated = " + timerIteration.Elapsed);
                TbMgr.EndUpdate();
                //Debug.Print("updateToolStates, EndUpdate = " + timerIteration.Elapsed);
                TbMgr.EventManager.SetEnabled(EventGroups.AllEvents, true);
                //Debug.Print("updateToolStates, events enabled = " + timerIteration.Elapsed);
                timerIteration.Restart();
            }

            frm.ultraLabel1.Text = "Time to Open = " + timerTotal.Elapsed.ToString();
            timerTotal.Stop();
            timerTotal = null;
            timerIteration.Stop();
            timerIteration = null;
        }

    }
}
